Scala Reflection Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root
  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package macros

  EXPERIMENTAL

  EXPERIMENTAL

  The base package for Scala macros.

  Macros are functions that are called by the compiler during compilation. Within these functions the programmer has access to compiler APIs. For example, it is possible to generate, analyze and typecheck code.

  See the Macros Guide on how to get started with Scala macros.

  Definition Classes
    reflect
-  package blackbox
  Definition Classes
    macros
-  package whitebox
  Definition Classes
    macros
- Aliases
- Attachments
- Enclosures
- Evals
- ExprUtils
- FrontEnds
- Infrastructure
- Internals
- Names
- ParseException
- Parsers
- ReificationException
- Reifiers
- TypecheckException
- Typers
- UnexpectedReificationException
- Universe

t

scala.reflect.macros

# Names 

###

#### trait Names extends AnyRef

EXPERIMENTAL

A slice of the Scala macros context that provides functions that generate fresh names.

In the current implementation, fresh names are more or less unique in the sense that within the same compilation run they are guaranteed not to clash with: 1) Results of past and future invocations of functions of `freshName` family 2) User-defined or macro-generated names that don't contain dollar symbols 3) Macro-generated names that are created by concatenating names from the first, second and third categories

Uniqueness of fresh names across compilation runs is not guaranteed, but that's something that we would like to improve upon in future releases. See https://issues.scala-lang.org/browse/SI-6879 for more information.

Self Type
  blackbox.Context
Source
  Names.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Context, Context
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Names
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1.  abstract def freshName[NameType <: blackbox.Context.Name](name: NameType): NameType

   Creates a more or less unique name having a given name as a prefix and having the same flavor (term name or type name) as the given name.

   Creates a more or less unique name having a given name as a prefix and having the same flavor (term name or type name) as the given name. Consult scala.reflect.macros.Names for more information on uniqueness of such names.

2.  abstract def freshName(name: String): String

   Creates a string that represents a more or less unique name having a given prefix.

   Creates a string that represents a more or less unique name having a given prefix. Consult scala.reflect.macros.Names for more information on uniqueness of such names.

3.  abstract def freshName(): String

   Creates a string that represents a more or less unique name.

   Creates a string that represents a more or less unique name. Consult scala.reflect.macros.Names for more information on uniqueness of such names.

4.  abstract def fresh[NameType <: blackbox.Context.Name](name: NameType): NameType

   Creates a more or less unique name having a given name as a prefix and having the same flavor (term name or type name) as the given name.

   Creates a more or less unique name having a given name as a prefix and having the same flavor (term name or type name) as the given name. Consult scala.reflect.macros.Names for more information on uniqueness of such names.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) use freshName instead

5.  abstract def fresh(name: String): String

   Creates a string that represents a more or less unique name having a given prefix.

   Creates a string that represents a more or less unique name having a given prefix. Consult scala.reflect.macros.Names for more information on uniqueness of such names.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) use freshName instead

6.  abstract def fresh(): String

   Creates a string that represents a more or less unique name.

   Creates a string that represents a more or less unique name. Consult scala.reflect.macros.Names for more information on uniqueness of such names.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) use freshName instead

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Names to any2stringadd[Names] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Names, B)
   Implicit
     This member is added by an implicit conversion from Names to ArrowAssoc[Names] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def ensuring(cond: (Names) ⇒ Boolean, msg: ⇒ Any): Names
   Implicit
     This member is added by an implicit conversion from Names to Ensuring[Names] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (Names) ⇒ Boolean): Names
   Implicit
     This member is added by an implicit conversion from Names to Ensuring[Names] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: ⇒ Any): Names
    Implicit
      This member is added by an implicit conversion from Names to Ensuring[Names] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): Names
    Implicit
      This member is added by an implicit conversion from Names to Ensuring[Names] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Names to StringFormat[Names] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  final def notify(): Unit
    Definition Classes
      AnyRef
21.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
22.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
23.  def toString(): String
    Definition Classes
      AnyRef → Any
24.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
25.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
26.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
27.  def →[B](y: B): (Names, B)
    Implicit
      This member is added by an implicit conversion from Names to ArrowAssoc[Names] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Names to any2stringadd[Names]

### Inherited by implicit conversion StringFormat from Names to StringFormat[Names]

### Inherited by implicit conversion Ensuring from Names to Ensuring[Names]

### Inherited by implicit conversion ArrowAssoc from Names to ArrowAssoc[Names]

### Ungrouped